#include <sys/mman.h>
#include "mtest.h"

static void *mbuffer;
static void *mbuffer_end;


void *sbrk_init(int size)
{
	if (1) { /* Force mapping at 1G to ease debugging */
	    mbuffer = mmap((void *)(1<<30), size, PROT_READ | PROT_WRITE,
			       MAP_PRIVATE | MAP_ANONYMOUS | MAP_FIXED, 0, 0);
	} else { /* Let the system choose */
		mbuffer = mmap(0, size, PROT_READ | PROT_WRITE,
			       MAP_PRIVATE | MAP_ANONYMOUS, 0, 0);
	}
	if (mbuffer == (typeof(mbuffer))-1)
		return (void *)-1;
	mbuffer_end = mbuffer + size;
	return mbuffer;
}


/* This is a definition of sbrk used by the various malloc implementations */
extern int _end;

static void *current_brk;

void *sbrk(int increment)
{
	void *prev;
	if (!current_brk) /* first time */
		current_brk = mbuffer;

	/* align to 8 (M_ALIGN) */
	prev = current_brk;
	current_brk += M_ALIGN(increment);

	/* if OOM, return -1 */
	if (current_brk > mbuffer_end) {
		current_brk = prev;
		return (void *)-1;
	}
	return prev;
}
