#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/mman.h>
#include "mtest.h"

/* These parameters can be chagned through evironment variables */
static int alloc_number = 1024;
static int alloc_maxsize = 1024;
static int alloc_loops = (1000*1000);
static int alloc_verbose = 0;

int main(int argc, char **argv)
{
	int randval;
	struct sched_param param;

	/* First, get parameters from environment */

	randval = time(NULL);
	if (getenv("RANDVAL"))
		randval = atoi(getenv("RANDVAL"));
	srand(randval);

	if (getenv("ALLOCPARAM")) {
		sscanf(getenv("ALLOCPARAM"), "%i,%i,%i",
		       &alloc_number, &alloc_maxsize, &alloc_loops);
	}
	if (getenv("ALLOCVERBOSE")) {
		alloc_verbose = 1;
		/* accept "0" as value */
		sscanf(getenv("ALLOCVERBOSE"), "%i", &alloc_verbose);
	}

	/* get as RT as possible */
	param.sched_priority = 1;
	sched_setscheduler(0, SCHED_FIFO, &param);
	mlockall(MCL_CURRENT | MCL_FUTURE);

	printf("Testing with randval=%i, allocs %i, maxsize %i, loops %i\n",
	       randval, alloc_number, alloc_maxsize, alloc_loops);

	testloop(alloc_number,alloc_maxsize, alloc_loops,
		 alloc_verbose);
	exit(0);
}

/* The following function is in rbmalloc but not in dlmalloc */
void __attribute__((weak)) rbm_show(FILE *f, void *min)
{
}
